---
title: Function() constructor
slug: Web/JavaScript/Reference/Global_Objects/Function/Function
tags:
  - Constructor
  - Function
  - JavaScript
  - Reference
---
<div>{{JSRef}}</div>

<p><span class="seoSummary">The <strong><code>Function</code> constructor</strong> creates a new <code>Function</code> <strong>object</strong>. Calling the constructor directly can create functions dynamically, but suffers from security and similar (but far less significant) performance issues to {{jsxref("eval")}}. However, unlike eval, the <code>Function</code> constructor creates functions which execute in the global scope only.</span></p>

<div>{{EmbedInteractiveExample("pages/js/function-constructor.html","shorter")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><code>new Function([<var>arg1 </var>[, <var>arg2 </var>[, ...<var>argN</var>]] ,] <var>functionBody</var>)</code></pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>arg1</var>, <var>arg2</var>, ... <var>argN</var></code></dt>
 <dd>Names to be used by the function as formal argument names. Each must be a string that corresponds to a valid JavaScript identifier, or a list of such strings separated with a comma. For example: "<code>x</code>", "<code>theValue</code>"—or "<code>x,theValue</code>".</dd>
 <dt><code><var>functionBody</var></code></dt>
 <dd>A string containing the JavaScript statements comprising the function definition.</dd>
</dl>

<h2 id="Description">Description</h2>

<p><code>Function</code> objects created with the <code>Function</code> constructor are parsed when the function is created. This is less efficient than declaring a function with a {{jsxref("Operators/function", "function expression", "", 1)}} or {{jsxref("Statements/function", "function statement", "", 1)}} and calling it within your code because such functions are parsed with the rest of the code.</p>

<p>All arguments passed to the function are treated as the names of the identifiers of the parameters in the function to be created, in the order in which they are passed. Omitting an argument will result in the value of that parameter being <code>undefined</code>.</p>

<p>Invoking the <code>Function</code> constructor as a function (without using the <code>new</code> operator) has the same effect as invoking it as a constructor.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Specifying_arguments_with_the_Function_constructor">Specifying arguments with the Function constructor</h3>

<p>The following code creates a <code>Function</code> object that takes two arguments.</p>

<pre class="brush: js notranslate">// Example can be run directly in your JavaScript console

// Create a function that takes two arguments, and returns the sum of those arguments
const adder = new Function('a', 'b', 'return a + b');

// Call the function
adder(2, 6);
// 8
</pre>

<p>The arguments "<code>a</code>" and "<code>b</code>" are formal argument names that are used in the function body, "<code>return a + b</code>".</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-function-constructor', 'Function constructor')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Function.Function")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Functions", "Functions and function scope", "", 1)}}</li>
 <li>{{jsxref("Statements/function", "function")}} statement</li>
 <li>{{jsxref("Operators/function", "function")}} expression</li>
 <li>{{jsxref("Statements/function*", "function*")}} statement</li>
 <li>{{jsxref("Operators/function*", "function*")}} expression</li>
 <li>{{jsxref("AsyncFunction")}}</li>
 <li>{{jsxref("GeneratorFunction")}}</li>
</ul>
